<script setup lang="ts">
import { ref, nextTick, provide } from 'vue'

import { type Product } from '@/types/Product'

import NavigationDrawer from '@/components/NavigationDrawer.vue'
import ProductList from '@/components/POScomponents/ProductList.vue'
import ReceiptDetailTable from './ReceiptDetailTable.vue'
import ReceiptCard from './ReceiptCard.vue'
import MemberCard from './MemberCard.vue'
import CashCard from './CashCard.vue'
import ReceiptDialog from './ReceiptDialog.vue'

import { useReceipetStore } from '@/stores/receipt'
import { useMembersStore } from '@/stores/member'
import { useProductsStore } from '@/stores/product'

const memberStore = useMembersStore()
const receiptStore = useReceipetStore()
const productStore = useProductsStore()
const dialog = ref(false)
const dialogDelete = ref(false)
const dialogNoitem = ref(false)
const dialogCashNotEnough = ref(false)

provide('receiptDialog', dialog)

//Hot Drinks
const products1 = ref<Product[]>([])
products1.value = productStore.Product1

//Cold Drinks
const products2 = ref<Product[]>([])
products2.value = productStore.Product2

//Frappé Drinks
const products3 = ref<Product[]>([])
products3.value = productStore.Product3

//Dessert
const products4 = ref<Product[]>([])
products4.value = productStore.Product4

const tab = ref(1)
const selected = (p: Product) => {
  receiptStore.addReceiptItem(p)
  nextTick(() => {
    if (divReceiptItems.value) divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
  })
}

const showReceipt = function () {
  if (receiptStore.receipt.total === 0 && receiptStore.receipt.paymentType === 'scan') {
    dialogNoitem.value = true
  } else if (
    receiptStore.receipt.receicedAmount === 0 &&
    receiptStore.receipt.paymentType === 'scan'
  ) {
    receiptStore.showReceiptDialog()
  } else if (receiptStore.receipt.total === 0) {
    dialogNoitem.value = true
  } else if (receiptStore.receipt.receicedAmount < receiptStore.receipt.total) {
    dialogCashNotEnough.value = true
  } else {
    receiptStore.showReceiptDialog()
  }
}

function closeDialog() {
  dialogNoitem.value = false
  dialogCashNotEnough.value = false
}

const showDelete = function () {
  if (
    receiptStore.receipt.totalBefore > 0 ||
    memberStore.currentMember ||
    receiptStore.receipt.receicedAmount > 0
  ) {
    dialogDelete.value = true
  } else {
    return
  }
}

const deleteConfirmed = () => {
  receiptStore.clear()
  dialogDelete.value = false
}

const deleteCancelled = () => {
  dialogDelete.value = false
}

const divReceiptItems = ref<HTMLElement | null>(null)
</script>

<template>
  <!-- <NavigationDrawer></NavigationDrawer> -->
  <div>
    <v-container style="background-color: #494949; max-width: 100%">
      <v-row>
        <v-col cols="12" md="6">
          <v-container style="padding: 0; margin-left: 18%">
            <v-row>
              <v-col cols="12">
                <div ref="divReceiptItems" style="height: 250; overflow: auto">
                  <v-sheet
                    min-width="300"
                    max-width="700"
                    height="300"
                    elevation="6"
                    style="background-color: #eae7de"
                  >
                    <ReceiptDetailTable></ReceiptDetailTable>
                  </v-sheet>
                </div>
              </v-col>
              <v-col cols="12">
                <v-sheet min-width="300" max-width="700" height="145" elevation="6" color="#eae7de">
                  <MemberCard></MemberCard>
                </v-sheet>
              </v-col>
              <v-col cols="12">
                <v-sheet min-width="300" max-width="700" height="124" elevation="6" color="#eae7de">
                  <ReceiptCard></ReceiptCard>
                </v-sheet>
              </v-col>
              <v-col cols="12">
                <v-sheet min-width="300" max-width="700" height="74" elevation="6" color="#eae7de">
                  <CashCard></CashCard>
                </v-sheet>
              </v-col>
              <v-col cols="12">
                <v-sheet min-width="300" max-width="700" height="80" elevation="6" color="#eae7de">
                  <v-container>
                    <v-row>
                      <v-col
                        ><v-btn
                          block
                          rounded="xl"
                          color="primary"
                          size="large"
                          @click="showReceipt()"
                          >Purchase</v-btn
                        ></v-col
                      >
                      <v-col
                        ><v-btn
                          block
                          rounded="xl"
                          size="large"
                          @click="showDelete()"
                          color="grey-darken-4"
                          >Cancel</v-btn
                        ></v-col
                      >
                    </v-row>
                  </v-container>
                </v-sheet>
              </v-col>
            </v-row>
          </v-container>
        </v-col>
        <v-col cols="12" md="6"
          ><v-sheet min-width="300" max-width="700" height="812" elevation="6" color="#212121">
            <v-tabs v-model="tab" color="primary" align-tabs="center">
              <v-tab :value="1">Hot Drinks</v-tab>
              <v-tab :value="2">Iced Drinks</v-tab>
              <v-tab :value="3">Frappé</v-tab>
              <v-tab :value="4">Desserts</v-tab>
            </v-tabs>
            <v-window v-model="tab">
              <v-window-item :value="1" style="margin-left: 25px">
                <ProductList :products="products1" @selected-product="selected"></ProductList>
              </v-window-item>
              <v-window-item :value="2" style="margin-left: 25px">
                <ProductList :products="products2" @selected-product="selected"></ProductList>
              </v-window-item>
              <v-window-item :value="3" style="margin-left: 25px">
                <ProductList :products="products3" @selected-product="selected"></ProductList>
              </v-window-item>
              <v-window-item :value="4" style="margin-left: 25px">
                <ProductList :products="products4" @selected-product="selected"></ProductList>
              </v-window-item>
            </v-window>
          </v-sheet>
        </v-col>
      </v-row>
      <!-- dialogDelete -->
      <v-dialog v-model="dialogDelete" max-width="500px">
        <v-card>
          <br />
          <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
          <v-spacer></v-spacer>
          <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
          <v-card-title align="center" class="text-h10">
            This action cannot be undone.<br />
            All values associated with this field will be lost.
          </v-card-title>
          <v-spacer></v-spacer>
          <div align="center">
            <div style="margin: 0 auto; max-width: 400px">
              <v-btn
                block
                style="background-color: #e11d48"
                color="white"
                variant="text"
                @click="deleteConfirmed()"
              >
                Yes
              </v-btn>
            </div>
          </div>
          <div align="center">
            <div
              style="
                margin: 0 auto;
                max-width: 400px;
                border: 1px solid #dfe1e6;
                border-radius: 5px;
                margin-top: 10px;
              "
            >
              <v-btn block color="primary" variant="text" @click="deleteCancelled()"> No </v-btn>
            </div>
          </div>
          <v-spacer></v-spacer>
          <br />
        </v-card>
      </v-dialog>

      <!-- dialogCashNotEnough -->
      <v-dialog v-model="dialogCashNotEnough" max-width="300px">
        <v-card>
          <v-card-title class="text-h5" style="text-align: center">
            <v-icon icon="mdi-alert" density="compact" size="small"></v-icon>Cash Not
            Enough.</v-card-title
          >
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="primary" variant="text" @click="closeDialog()">OK</v-btn>
            <v-spacer></v-spacer>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <!-- dialogNoitem -->
      <v-dialog v-model="dialogNoitem" max-width="400px">
        <v-card>
          <v-card-title class="text-h5" style="text-align: center"
            ><v-icon icon="mdi-alert" density="compact" size="small"></v-icon>Please Select Some
            Menu.</v-card-title
          >
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="primary" variant="text" @click="closeDialog()">OK</v-btn>
            <v-spacer></v-spacer>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-container>
  </div>
  <ReceiptDialog></ReceiptDialog>
</template>
